let peerList = [];
let currentIp = "";
let connected = false;


window.zeroFrame = new ZeroFrame();
zeroFrame.onRequest = (cmd, message) => {
	if(cmd === "peerReceive") {
		console.log("recv", message.params);
		zeroFrame.cmd("peerValid", {
			hash: message.params.hash
		});

		const data = message.params.message;
		if(data.ping) {
			if(message.params.ip != "self") {
				zeroFrame.cmd("peerSend", {
					ip: message.params.ip,
					message: {
						pong: true
					}
				});
			}
		} else if(data.pong) {
			if(peerList.indexOf(message.params.ip) == -1) {
				peerList.push(message.params.ip);
				showPeerList();
			}
		} else if(data.connect) {
			if(!connected || currentIp != message.params.ip) {
				zeroFrame.cmd("wrapperConfirm", ["Open a communication channel with <b>" + message.params.ip + "</b>?"], () => {
					connected = true;
					currentIp = message.params.ip;
					showConnection();

					zeroFrame.cmd("peerSend", {
						ip: message.params.ip,
						to: message.params.hash,
						message: {
							connect: true
						}
					});
				});
			}
		} else if(data.text) {
			showMessage(message.params.ip, data.text);
		}
	}
};

setInterval(() => {
	zeroFrame.cmd("peerBroadcast", {
		message: {
			ping: true
		},
		broadcast: true
	}, e => {
		console.warn(e);
	});
}, 10000);
zeroFrame.cmd("peerBroadcast", {
	message: {
		ping: true
	},
	broadcast: true
}, e => {
	console.warn(e);
});


function showPeerList() {
	document.getElementById("peers").innerHTML = (
		peerList
			.map(ip => "<a href='#' onclick='connect(\"" + ip + "\")'>" + ip + "</a>")
			.join("\n")
	);
}


function connect(ip) {
	zeroFrame.cmd("wrapperNotification", ["notification", "Opening a communication channel with <b>" + ip + "</b>"]);

	currentIp = ip;
	connected = false;
	showConnection();

	zeroFrame.cmd("peerSend", {
		ip: ip,
		message: {
			connect: true
		}
	}, ({message}) => {
		if(message.connect) {
			zeroFrame.cmd("wrapperNotification", ["notification", "A communication channel with <b>" + ip + "</b> opened!"]);
			currentIp = ip;
			connected = true;

			showConnection();
		}
	});
}

function showConnection() {
	if(currentIp) {
		document.getElementById("channel").innerHTML = "You <-> " + currentIp + " (" + (connected ? "connected" : "connecting") + ")";
	} else {
		document.getElementById("channel").innerHTML = "None";
	}
}


function send() {
	const text = document.getElementById("msg").value;
	document.getElementById("msg").value = "";

	if(!currentIp) {
		zeroFrame.cmd("wrapperNotification", ["error", "Not connected to anyone"]);
		return;
	} else if(!connected) {
		zeroFrame.cmd("wrapperNotification", ["error", "Still connecting to " + currentIp]);
		return;
	}

	zeroFrame.cmd("peerSend", {ip: currentIp, message: {text}});
	showMessage("self", text);
}

function showMessage(ip, text) {
	if(ip == "self") {
		ip = "127.0.0.1 [You]";
	} else if(ip == currentIp) {
		ip = ip + " [That guy]";
	} else {
		ip = ip + " [???]";
	}

	const messages = document.getElementById("messages");
	messages.innerHTML = `<b>${ip}</b>: <i>${text}</i>\n` + messages.innerHTML;
}